> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://virtuous.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://virtuous.ferndocs.com/_mcp/server.

# Update a Pledge

PUT https://api.virtuoussoftware.com/api/v2/Pledge/{pledgeId}
Content-Type: application/json

Similar to other update methods in the API, excluding a property will remove it's value from the object. 
If you're only updating a single property, the entire model is still required.

Reference: https://virtuous.ferndocs.com/reference/crm-plus/giving/update-a-pledge

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.virtuoussoftware.com` (https://api.virtuoussoftware.com, default)
- `{{baseUrl}}api` ({{baseUrl}}api)

## Request

### Path parameters

- `pledgeId` (string, required)

### Body (application/json)

This endpoint expects an object.

- `amountPledged` (string, optional)
- `frequency` (string, optional)
- `pledgeDate` (string, optional)
- `expectedFulfillmentDate` (string, optional)
- `giftAskId` (string, optional)
- `segmentId` (string, optional)
- `projectId` (string, optional)
- `isPrivate` (string, optional)
- `payments` (list of ApiV2PledgePledgeIdPutRequestBodyContentApplicationJsonSchemaPaymentsItems, optional)
- `customFields` (list of ApiV2PledgePledgeIdPutRequestBodyContentApplicationJsonSchemaCustomFieldsItems, optional)

## Response

### 200

OK

- `id` (string, optional)
- `contactId` (string, optional)
- `amountPledged` (string, optional)
- `frequency` (string, optional)
- `pledgeDate` (string, optional)
- `expectedFulfillmentDate` (string, optional)
- `createDateTimeUtc` (string, optional)
- `createdByUser` (string, optional)
- `modifiedDateTimeUtc` (string, optional)
- `modifiedByUser` (string, optional)
- `segmentId` (string, optional)
- `segment` (string, optional)
- `projectId` (string, optional)
- `project` (string, optional)
- `isPrivate` (string, optional)
- `status` (string, optional)
- `payments` (list of ApiV2PledgePledgeIdPutResponsesContentApplicationJsonSchemaPaymentsItems, optional)
- `customFields` (list of ApiV2PledgePledgeIdPutResponsesContentApplicationJsonSchemaCustomFieldsItems, optional)

## Errors

### 400 Bad Request Error

BadRequest

- `any`

## Types

### ApiV2PledgePledgeIdPutRequestBodyContentApplicationJsonSchemaPaymentsItems

- `expectedPaymentDate` (string, optional)
- `expectedAmount` (string, optional)

### ApiV2PledgePledgeIdPutRequestBodyContentApplicationJsonSchemaCustomFieldsItems

- `name` (string, optional)
- `value` (string, optional)

### ApiV2PledgePledgeIdPutResponsesContentApplicationJsonSchemaPaymentsItems

- `id` (string, optional)
- `expectedPaymentDate` (string, optional)
- `expectedAmount` (string, optional)
- `giftId` (string, optional)
- `actualAmount` (string, optional)

### ApiV2PledgePledgeIdPutResponsesContentApplicationJsonSchemaCustomFieldsItems

- `name` (string, optional)
- `value` (string, optional)
- `displayName` (string, optional)

## Examples

**Request**

```json
{
  "amountPledged": "<double:required>",
  "frequency": "<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>",
  "pledgeDate": "<dateTime:required>",
  "expectedFulfillmentDate": "<dateTime:required>",
  "giftAskId": "<integer:optional>",
  "segmentId": "<integer:optional>",
  "projectId": "<integer:optional>",
  "isPrivate": "<boolean:required>",
  "payments": [
    {
      "expectedPaymentDate": "<dateTime:required>",
      "expectedAmount": "<double:required>"
    },
    {
      "expectedPaymentDate": "<dateTime:required>",
      "expectedAmount": "<double:required>"
    }
  ],
  "customFields": [
    {
      "name": "<string:required>",
      "value": "<string:optional>"
    },
    {
      "name": "<string:required>",
      "value": "<string:optional>"
    }
  ]
}
```

**Response**

```json
{
  "id": "<integer>",
  "contactId": "<integer>",
  "amountPledged": "<double>",
  "frequency": "<string>",
  "pledgeDate": "<dateTime>",
  "expectedFulfillmentDate": "<dateTime>",
  "createDateTimeUtc": "<dateTime>",
  "createdByUser": "<string>",
  "modifiedDateTimeUtc": "<dateTime>",
  "modifiedByUser": "<string>",
  "segmentId": "<integer>",
  "segment": "<string>",
  "projectId": "<integer>",
  "project": "<string>",
  "isPrivate": "<boolean>",
  "status": "<string>",
  "payments": [
    {
      "id": "<integer>",
      "expectedPaymentDate": "<dateTime>",
      "expectedAmount": "<double>",
      "giftId": "<integer>",
      "actualAmount": "<double>"
    },
    {
      "id": "<integer>",
      "expectedPaymentDate": "<dateTime>",
      "expectedAmount": "<double>",
      "giftId": "<integer>",
      "actualAmount": "<double>"
    }
  ],
  "customFields": [
    {
      "name": "<string>",
      "value": "<string>",
      "displayName": "<string>"
    },
    {
      "name": "<string>",
      "value": "<string>",
      "displayName": "<string>"
    }
  ]
}
```

**SDK Code**

```python Giving_updateAPledge_example
import requests

url = "https://api.virtuoussoftware.com/api/v2/Pledge/pledgeId"

payload = {
    "amountPledged": "<double:required>",
    "frequency": "<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>",
    "pledgeDate": "<dateTime:required>",
    "expectedFulfillmentDate": "<dateTime:required>",
    "giftAskId": "<integer:optional>",
    "segmentId": "<integer:optional>",
    "projectId": "<integer:optional>",
    "isPrivate": "<boolean:required>",
    "payments": [
        {
            "expectedPaymentDate": "<dateTime:required>",
            "expectedAmount": "<double:required>"
        },
        {
            "expectedPaymentDate": "<dateTime:required>",
            "expectedAmount": "<double:required>"
        }
    ],
    "customFields": [
        {
            "name": "<string:required>",
            "value": "<string:optional>"
        },
        {
            "name": "<string:required>",
            "value": "<string:optional>"
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript Giving_updateAPledge_example
const url = 'https://api.virtuoussoftware.com/api/v2/Pledge/pledgeId';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"amountPledged":"<double:required>","frequency":"<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>","pledgeDate":"<dateTime:required>","expectedFulfillmentDate":"<dateTime:required>","giftAskId":"<integer:optional>","segmentId":"<integer:optional>","projectId":"<integer:optional>","isPrivate":"<boolean:required>","payments":[{"expectedPaymentDate":"<dateTime:required>","expectedAmount":"<double:required>"},{"expectedPaymentDate":"<dateTime:required>","expectedAmount":"<double:required>"}],"customFields":[{"name":"<string:required>","value":"<string:optional>"},{"name":"<string:required>","value":"<string:optional>"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Giving_updateAPledge_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.virtuoussoftware.com/api/v2/Pledge/pledgeId"

	payload := strings.NewReader("{\n  \"amountPledged\": \"<double:required>\",\n  \"frequency\": \"<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>\",\n  \"pledgeDate\": \"<dateTime:required>\",\n  \"expectedFulfillmentDate\": \"<dateTime:required>\",\n  \"giftAskId\": \"<integer:optional>\",\n  \"segmentId\": \"<integer:optional>\",\n  \"projectId\": \"<integer:optional>\",\n  \"isPrivate\": \"<boolean:required>\",\n  \"payments\": [\n    {\n      \"expectedPaymentDate\": \"<dateTime:required>\",\n      \"expectedAmount\": \"<double:required>\"\n    },\n    {\n      \"expectedPaymentDate\": \"<dateTime:required>\",\n      \"expectedAmount\": \"<double:required>\"\n    }\n  ],\n  \"customFields\": [\n    {\n      \"name\": \"<string:required>\",\n      \"value\": \"<string:optional>\"\n    },\n    {\n      \"name\": \"<string:required>\",\n      \"value\": \"<string:optional>\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Giving_updateAPledge_example
require 'uri'
require 'net/http'

url = URI("https://api.virtuoussoftware.com/api/v2/Pledge/pledgeId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"amountPledged\": \"<double:required>\",\n  \"frequency\": \"<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>\",\n  \"pledgeDate\": \"<dateTime:required>\",\n  \"expectedFulfillmentDate\": \"<dateTime:required>\",\n  \"giftAskId\": \"<integer:optional>\",\n  \"segmentId\": \"<integer:optional>\",\n  \"projectId\": \"<integer:optional>\",\n  \"isPrivate\": \"<boolean:required>\",\n  \"payments\": [\n    {\n      \"expectedPaymentDate\": \"<dateTime:required>\",\n      \"expectedAmount\": \"<double:required>\"\n    },\n    {\n      \"expectedPaymentDate\": \"<dateTime:required>\",\n      \"expectedAmount\": \"<double:required>\"\n    }\n  ],\n  \"customFields\": [\n    {\n      \"name\": \"<string:required>\",\n      \"value\": \"<string:optional>\"\n    },\n    {\n      \"name\": \"<string:required>\",\n      \"value\": \"<string:optional>\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Giving_updateAPledge_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.virtuoussoftware.com/api/v2/Pledge/pledgeId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"amountPledged\": \"<double:required>\",\n  \"frequency\": \"<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>\",\n  \"pledgeDate\": \"<dateTime:required>\",\n  \"expectedFulfillmentDate\": \"<dateTime:required>\",\n  \"giftAskId\": \"<integer:optional>\",\n  \"segmentId\": \"<integer:optional>\",\n  \"projectId\": \"<integer:optional>\",\n  \"isPrivate\": \"<boolean:required>\",\n  \"payments\": [\n    {\n      \"expectedPaymentDate\": \"<dateTime:required>\",\n      \"expectedAmount\": \"<double:required>\"\n    },\n    {\n      \"expectedPaymentDate\": \"<dateTime:required>\",\n      \"expectedAmount\": \"<double:required>\"\n    }\n  ],\n  \"customFields\": [\n    {\n      \"name\": \"<string:required>\",\n      \"value\": \"<string:optional>\"\n    },\n    {\n      \"name\": \"<string:required>\",\n      \"value\": \"<string:optional>\"\n    }\n  ]\n}")
  .asString();
```

```php Giving_updateAPledge_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.virtuoussoftware.com/api/v2/Pledge/pledgeId', [
  'body' => '{
  "amountPledged": "<double:required>",
  "frequency": "<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>",
  "pledgeDate": "<dateTime:required>",
  "expectedFulfillmentDate": "<dateTime:required>",
  "giftAskId": "<integer:optional>",
  "segmentId": "<integer:optional>",
  "projectId": "<integer:optional>",
  "isPrivate": "<boolean:required>",
  "payments": [
    {
      "expectedPaymentDate": "<dateTime:required>",
      "expectedAmount": "<double:required>"
    },
    {
      "expectedPaymentDate": "<dateTime:required>",
      "expectedAmount": "<double:required>"
    }
  ],
  "customFields": [
    {
      "name": "<string:required>",
      "value": "<string:optional>"
    },
    {
      "name": "<string:required>",
      "value": "<string:optional>"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Giving_updateAPledge_example
using RestSharp;

var client = new RestClient("https://api.virtuoussoftware.com/api/v2/Pledge/pledgeId");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"amountPledged\": \"<double:required>\",\n  \"frequency\": \"<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>\",\n  \"pledgeDate\": \"<dateTime:required>\",\n  \"expectedFulfillmentDate\": \"<dateTime:required>\",\n  \"giftAskId\": \"<integer:optional>\",\n  \"segmentId\": \"<integer:optional>\",\n  \"projectId\": \"<integer:optional>\",\n  \"isPrivate\": \"<boolean:required>\",\n  \"payments\": [\n    {\n      \"expectedPaymentDate\": \"<dateTime:required>\",\n      \"expectedAmount\": \"<double:required>\"\n    },\n    {\n      \"expectedPaymentDate\": \"<dateTime:required>\",\n      \"expectedAmount\": \"<double:required>\"\n    }\n  ],\n  \"customFields\": [\n    {\n      \"name\": \"<string:required>\",\n      \"value\": \"<string:optional>\"\n    },\n    {\n      \"name\": \"<string:required>\",\n      \"value\": \"<string:optional>\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Giving_updateAPledge_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "amountPledged": "<double:required>",
  "frequency": "<string:Once|Weekly|Monthly|Quarterly|Semiannually|Annually|Biennially|Custom:required>",
  "pledgeDate": "<dateTime:required>",
  "expectedFulfillmentDate": "<dateTime:required>",
  "giftAskId": "<integer:optional>",
  "segmentId": "<integer:optional>",
  "projectId": "<integer:optional>",
  "isPrivate": "<boolean:required>",
  "payments": [
    [
      "expectedPaymentDate": "<dateTime:required>",
      "expectedAmount": "<double:required>"
    ],
    [
      "expectedPaymentDate": "<dateTime:required>",
      "expectedAmount": "<double:required>"
    ]
  ],
  "customFields": [
    [
      "name": "<string:required>",
      "value": "<string:optional>"
    ],
    [
      "name": "<string:required>",
      "value": "<string:optional>"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.virtuoussoftware.com/api/v2/Pledge/pledgeId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```